// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const AccountPlan = sequelize.define('accountPlan', {
    code: {
      type: DataTypes.STRING,
    },
    description: {
      type: DataTypes.STRING,
    },
  }, {
    tableName: 'account_plan',
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  AccountPlan.associate = (models) => {
    AccountPlan.belongsTo(models.accountPlan, {
      foreignKey: {
        name: 'parentIdKey',
        field: 'parent_id',
      },
      as: 'parent',
    });
    AccountPlan.hasMany(models.organization, {
      foreignKey: {
        name: 'planIdKey',
        field: 'plan_id',
      },
      as: 'planOrganizations',
    });
    AccountPlan.hasMany(models.accountPlan, {
      foreignKey: {
        name: 'parentIdKey',
        field: 'parent_id',
      },
      as: 'parentAccountPlans',
    });
    AccountPlan.hasMany(models.account, {
      foreignKey: {
        name: 'planIdKey',
        field: 'plan_id',
      },
      as: 'planAccounts',
    });
  };

  return AccountPlan;
};
