// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const Account = sequelize.define('account', {
    description: {
      type: DataTypes.STRING,
    },
    functions: {
      type: DataTypes.ARRAY(DataTypes.ENUM(
        'cash_account',
        'vat_account',
      )),
    },
    number: {
      type: DataTypes.STRING,
    },
  }, {
    tableName: 'account',
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  Account.associate = (models) => {
    Account.belongsTo(models.option, {
      foreignKey: {
        name: 'typeKey',
        field: 'type',
      },
      as: 'type',
    });
    Account.belongsTo(models.accountPlan, {
      foreignKey: {
        name: 'planIdKey',
        field: 'plan_id',
      },
      as: 'plan',
    });
    Account.belongsTo(models.taxGroup, {
      foreignKey: {
        name: 'vatGroupIdKey',
        field: 'vat_group_id',
      },
      as: 'vatGroup',
    });
    Account.belongsToMany(models.organization, {
      through: 'organizationAccounts',
      foreignKey: 'account_id',
      otherKey: 'organization_id',
    });
    Account.hasMany(models.accountBalance, {
      foreignKey: {
        name: 'accountIdKey',
        field: 'account_id',
      },
      as: 'accountBalances',
    });
    Account.hasMany(models.verificationRow, {
      foreignKey: {
        name: 'accountIdKey',
        field: 'account_id',
      },
      as: 'verificationRows',
    });
  };

  return Account;
};
