// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const AreaCountry = sequelize.define('areaCountry', {
    code: {
      type: DataTypes.STRING,
    },
    name: {
      type: DataTypes.STRING,
    },
    currency: {
      type: DataTypes.STRING,
    },
    plan: {
      type: DataTypes.INTEGER,
    },
    xtra: {
      type: DataTypes.JSONB,
    },
  }, {
    tableName: 'area_country',
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  AreaCountry.associate = (models) => {
    AreaCountry.belongsTo(models.areaCountry, {
      foreignKey: {
        name: 'parentIdKey',
        field: 'parent_id',
      },
      as: 'parent',
    });
    AreaCountry.hasMany(models.areaCountry, {
      foreignKey: {
        name: 'parentIdKey',
        field: 'parent_id',
      },
      as: 'parentAreaCountries',
    });
    AreaCountry.hasMany(models.organization, {
      foreignKey: {
        name: 'countryIdKey',
        field: 'country_id',
      },
      as: 'countryOrganizations',
    });
  };

  return AreaCountry;
};
