// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const Organization = sequelize.define('organization', {
    name: {
      type: DataTypes.STRING,
    },
    url: {
      type: DataTypes.STRING,
    },
    description: {
      type: DataTypes.STRING,
    },
    group: {
      type: DataTypes.STRING,
    },
    xtra: {
      type: DataTypes.JSONB,
    },
    organizationNumber: {
      type: DataTypes.STRING,
    },
  }, {
    tableName: 'organization',
    underscored: true,
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  Organization.associate = (models) => {
    Organization.belongsTo(models.accountPlan, {
      foreignKey: {
        name: 'planIdKey',
        field: 'plan_id',
      },
      as: 'plan',
    });
    Organization.belongsTo(models.areaCountry, {
      foreignKey: {
        name: 'countryIdKey',
        field: 'country_id',
      },
      as: 'country',
    });
    Organization.belongsToMany(models.account, {
      through: 'organizationAccounts',
      foreignKey: 'organization_id',
      otherKey: 'account_id',
    });
    Organization.hasMany(models.accountBalance, {
      foreignKey: {
        name: 'organizationIdKey',
        field: 'organization_id',
      },
      as: 'accountBalances',
    });
    Organization.hasMany(models.serie, {
      foreignKey: {
        name: 'organizationIdKey',
        field: 'organization_id',
      },
      as: 'series',
    });
    Organization.hasMany(models.user, {
      foreignKey: {
        name: 'organizationIdKey',
        field: 'organization_id',
      },
      as: 'users',
    });
    Organization.hasMany(models.settingOrganization, {
      foreignKey: {
        name: 'organizationIdKey',
        field: 'organization_id',
      },
      as: 'settingOrganizations',
    });
  };

  return Organization;
};
