// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const Setting = sequelize.define('setting', {
    key: {
      type: DataTypes.STRING,
      primaryKey: true,
    },
    value: {
      type: DataTypes.STRING,
    },
    scope: {
      type: DataTypes.ENUM(
        'global',
        'organization',
        'user',
      ),
    },
    help: {
      type: DataTypes.STRING,
    },
  }, {
    tableName: 'setting',
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  Setting.associate = (models) => {
    Setting.hasMany(models.settingUser, {
      foreignKey: {
        name: 'keyKey',
        field: 'key',
      },
      target: {
        name: 'key',
      },
      as: 'keySettingUsers',
    });
    Setting.hasMany(models.settingOrganization, {
      foreignKey: {
        name: 'keyKey',
        field: 'key',
      },
      target: {
        name: 'key',
      },
      as: 'keySettingOrganizations',
    });
  };

  return Setting;
};
