// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const User = sequelize.define('user', {
    email: {
      type: DataTypes.STRING,
    },
    firstName: {
      type: DataTypes.STRING,
    },
    lastName: {
      type: DataTypes.STRING,
    },
    xtra: {
      type: DataTypes.JSONB,
    },
  }, {
    tableName: 'user',
    underscored: true,
    timestamps: false,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  User.associate = (models) => {
    User.belongsTo(models.organization, {
      foreignKey: {
        name: 'organizationIdKey',
        field: 'organization_id',
      },
      as: 'organization',
    });
    User.hasMany(models.job, {
      foreignKey: {
        name: 'userIdKey',
        field: 'user_id',
      },
      as: 'jobs',
    });
    User.hasMany(models.branch, {
      foreignKey: {
        name: 'userIdKey',
        field: 'user_id',
      },
      as: 'branches',
    });
    User.hasMany(models.verification, {
      foreignKey: {
        name: 'userIdKey',
        field: 'user_id',
      },
      as: 'verifications',
    });
    User.hasMany(models.settingUser, {
      foreignKey: {
        name: 'userIdKey',
        field: 'user_id',
      },
      as: 'settingUsers',
    });
  };

  return User;
};
