// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models
module.exports = (sequelize, DataTypes) => {
  const { Sequelize } = sequelize;
  // This section contains the fields of your model, mapped to your table's columns.
  // Learn more here: https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model
  const Verification = sequelize.define('verification', {
    createdAt: {
      type: DataTypes.DATE,
    },
    updatedAt: {
      type: DataTypes.DATE,
    },
    description: {
      type: DataTypes.STRING,
    },
    branchId: {
      type: DataTypes.INTEGER,
    },
    verNr: {
      type: DataTypes.STRING,
    },
    complete: {
      type: DataTypes.BOOLEAN,
      defaultValue: false,
    },
    frozen: {
      type: DataTypes.BOOLEAN,
      defaultValue: false,
    },
    templateId: {
      type: DataTypes.INTEGER,
    },
    number: {
      type: DataTypes.INTEGER,
    },
  }, {
    tableName: 'verification',
    underscored: true,
    schema: process.env.DATABASE_SCHEMA,
  });

  // This section contains the relationships for this model. See: https://docs.forestadmin.com/documentation/v/v6/reference-guide/relationships#adding-relationships.
  Verification.associate = (models) => {
    Verification.belongsTo(models.serie, {
      foreignKey: {
        name: 'serieIdKey',
        field: 'serie_id',
      },
      as: 'serie',
    });
    Verification.belongsTo(models.user, {
      foreignKey: {
        name: 'userIdKey',
        field: 'user_id',
      },
      as: 'user',
    });
    Verification.hasMany(models.verificationRow, {
      foreignKey: {
        name: 'verificationIdKey',
        field: 'verification_id',
      },
      as: 'verificationRows',
    });
  };

  return Verification;
};
